1#!/bin/sh
2
3# This script acts as a simple interface for building extensions.
4# It primarily used by the perl Makefile:
5#
6# d_dummy $(dynamic_ext): miniperl preplibrary FORCE
7# 	@sh ext/util/make_ext dynamic $@ MAKE=$(MAKE) LIBPERL_A=$(LIBPERL)
8#
9# It may be deleted in a later release of perl so try to
10# avoid using it for other purposes.
11
12target=$1;  shift
13extspec=$1; shift
14makecmd=$1; shift  # Should be something like MAKE=make
15passthru="$*" # allow extra macro=value to be passed through
16echo ""
17
18# Previously, $make was taken from config.sh.  However, the user might
19# instead be running a possibly incompatible make.  This might happen if
20# the user types "gmake" instead of a plain "make", for example.  The
21# correct current value of MAKE will come through from the main perl
22# makefile as MAKE=/whatever/make in $makecmd.  We'll be cautious in
23# case third party users of this script (are there any?) don't have the
24# MAKE=$(MAKE) argument, which was added after 5.004_03.
25case "$makecmd" in
26MAKE=*)
27	eval $makecmd
28	;;
29*)	echo 'ext/util/make_ext:  WARNING:  Please include MAKE=$(MAKE)'
30	echo '	in your call to make_ext.  See ext/util/make_ext for details.'
31	exit 1
32	;;
33esac
34
35
36case $CONFIG in
37'')
38    if test -f config.sh; then TOP=.;
39    elif test -f ../config.sh; then TOP=..;
40    elif test -f ../../config.sh; then TOP=../..;
41    elif test -f ../../../config.sh; then TOP=../../..;
42    elif test -f ../../../../config.sh; then TOP=../../../..;
43    else
44        echo "Can't find config.sh generated by Configure"; exit 1
45    fi
46    . $TOP/config.sh
47    ;;
48esac
49
50if test "X$extspec" = X; then
51	echo "make_ext: no extension specified"
52	exit 1;
53fi
54
55# The Perl Makefile.SH will expand all extensions to
56#	lib/auto/X/X.a  (or lib/auto/X/Y/Y.a if nested)
57# A user wishing to run make_ext might use
58#	X (or X/Y or X::Y if nested)
59
60# canonise into X/Y form (pname)
61case "$extspec" in
62lib*)	# Remove lib/auto prefix and /*.* suffix
63	pname=`echo "$extspec" | sed -e 's:^lib/auto/::' -e 's:/[^/]*\.[^/]*$::' ` ;;
64ext*)	# Remove ext/ prefix and /pm_to_blib suffix
65	pname=`echo "$extspec" | sed -e 's:^ext/::' -e 's:/pm_to_blib$::' ` ;;
66*::*)	# Convert :: to /
67	pname=`echo "$extspec" | sed -e 's/::/\//g' ` ;;
68*)	pname="$extspec" ;;
69esac
70# echo "Converted $extspec to $pname"
71
72mname=`echo "$pname"   | sed -e 's!/!::!g'`
73depth=`echo "$pname"   | sed -e 's![^/][^/]*!..!g'`
74makefile=Makefile
75makeargs=''
76makeopts=''
77
78if test ! -d "ext/$pname"; then
79    echo "	Skipping $extspec (directory does not exist)"
80    exit 0 # not an error ?
81fi
82
83# XXX should find the race and fix it
84case "$mname" in
85SDBM_File) makeopts="$makeopts -j1";;
86esac
87
88echo "	Making $mname ($target)"
89
90cd ext/$pname
91
92# check link type and do any preliminaries.  Valid link types are
93# 'dynamic', 'static', and 'static_pic' (the last one respects
94# CCCDLFLAGS such as -fPIC -- see static_target in the main Makefile.SH)
95case "$target" in
96dynamic)    makeargs="LINKTYPE=dynamic";
97	    target=all
98	    ;;
99static)     makeargs="LINKTYPE=static CCCDLFLAGS="
100	    target=all
101	    ;;
102static_pic) makeargs="LINKTYPE=static"
103	    target=all
104	    ;;
105nonxs)      makeargs="";
106	    target=all
107	    ;;
108
109*clean) # If Makefile has been moved to Makefile.old by a make clean
110	    # then use Makefile.old for realclean rather than rebuild it
111	    if test ! -f $makefile -a -f Makefile.old; then
112		makefile=Makefile.old
113		makeopts="-f $makefile"
114		echo "Note: Using Makefile.old"
115	    fi
116	    ;;
117
118*)	# for the time being we are strict about what make_ext is used for
119	echo "make_ext: unknown make target '$target'"; exit 1
120	;;
121'')	echo "make_ext: no make target specified (eg static or dynamic)"; exit 1
122	;;
123esac
124
125if test ! -f $makefile ; then
126	test -f Makefile.PL && ../$depth/miniperl -I../$depth/lib Makefile.PL INSTALLDIRS=perl PERL_CORE=1 $passthru
127fi
128if test ! -f $makefile ; then
129	if test -f Makefile.SH; then
130		echo "Warning: Writing $makefile from old-style Makefile.SH!"
131		sh Makefile.SH
132	else
133		echo "Warning: No Makefile!"
134	fi
135fi
136
137case "$target" in
138clean)		;;
139realclean)	;;
140*)	# Give makefile an opportunity to rewrite itself.
141	# reassure users that life goes on...
142	$MAKE config $passthru || echo "$MAKE config failed, continuing anyway..."
143	;;
144esac
145
146$MAKE $makeopts $target $makeargs $passthru || exit
147
148exit $?
149